<?php

namespace CreoCode\ContaoColumns\Component\ContentElement;
use Contao\PageModel;

class ColsPart extends \ContentElement
{

	/**
	 * Template
	 * @var string
	 */
	protected $strTemplate = 'ce_colsPart';

	/**
	 * Set-Type
	 */
	protected $strSet;

	/**
	 * Display a wildcard in the back end
	 * @return string
	 */
	public function generate() {

        $backendColumnView = false;
        if (isset($GLOBALS['_tmp_columns_backend_view']) && $GLOBALS['_tmp_columns_backend_view']) {
            $backendColumnView = true;
        }

        if (TL_MODE == 'BE' && !$backendColumnView) {
            $this->Template = new \BackendTemplate('be_column_element');
            $this->Template->setColor = '#'.$this->column_color;

            $this->Template->colsetTitle = $GLOBALS['TL_LANG']['MSC']['colsPart'];
            $this->Template->colsetSubtitle = '<span class="count">'.$GLOBALS['TL_LANG']['MSC']['cols'].': '.$this->column_amount.'</span> | <span class="name">'.$GLOBALS['TL_LANG']['MSC']['name'].': '.$this->column_name.'</span>';
            $this->Template->colsetParent = $this->column_parent;
            $this->Template->type = $this->type;
            $this->Template->id = $this->id;
            $this->Template->backendColumnView = $backendColumnView;

            return $this->Template->parse();
        }

        return parent::generate();
	}

	/**
	 * Generate content element
	 * @return string
	 */
	protected function compile()
	{
        $columns = $this->column_amount;
        $backendColumnView = false;

        if (isset($GLOBALS['_tmp_columns_backend_view']) && $GLOBALS['_tmp_columns_backend_view']) {
            $this->strTemplate = 'be_colsPart';
            $backendColumnView = true;
        }
        $this->Template = new \FrontendTemplate($this->strTemplate);
        $this->Template->backendColumnView = $backendColumnView;

        // Gap
        $gapArray = '';
        $containermarginhorizontal = 0;
        $containermarginvertical = 0;
		if($this->column_usecustomgap == 1 && $this->column_gap) {
            $gapArray = unserialize($this->column_gap);
        } else if(isset($GLOBALS['objPage'])) {
            $rootPage = PageModel::findByPk($GLOBALS['objPage']->rootId);
            if($rootPage->column_usegap == 1 && $rootPage->column_gap) {
                $gapArray = unserialize($rootPage->column_gap);
            }
        }
        $this->Template->gap_col = '';
        if ($gapArray) {
            foreach ($gapArray as $key => $gap) {
                if ($key !== 'unit') {
                    $this->Template->gap_col .= 'padding-'.$key.':'.$gap.$gapArray['unit'].';';
                }
            }
        }

        $colClasses = '';
        $colSizes = [];
        if (isset($this->column_sizes)) {
            $colSizes = unserialize($this->column_sizes);
        }
        foreach ($colSizes as $size) {
            $colSetSizeArray = unserialize($this->{'columns_'.$size});
            if ($colSetSizeArray[($this->column_sortid)]['width'] === 'auto') {
                $colClasses .= ' col-' . $size;
            } else {
                $colClasses .= ' col-' . $size . '-' . $colSetSizeArray[($this->column_sortid)]['width'];
            }

            if ($colSetSizeArray[($this->column_sortid)]['offset'] != NULL) {
                $colClasses .= ' col-' . $size . '-offset-' . $colSetSizeArray[($this->column_sortid)]['offset'];
            }
            if ($colSetSizeArray[($this->column_sortid)]['order'] != NULL) {
                $colClasses .= ' col-' . $size . '-order-' . $colSetSizeArray[($this->column_sortid)]['order'];
            }
            if ($colSetSizeArray[($this->column_sortid)]['align'] != NULL) {
                $colClasses .= ' col-' . $size . '-align-' . $colSetSizeArray[($this->column_sortid)]['align'];
            }
        }

        if (unserialize($this->column_expert)[($this->column_sortid)]['cssClass'] != NULL) {
            $colClasses .= ' ' . unserialize($this->column_expert)[($this->column_sortid)]['cssClass'];
        }

		$this->Template->column = 'ce_colsPart' . ' col_' . ($this->column_sortid+1) . $colClasses . (($this->column_sortid == $columns-1) ? ' last' : '');
	}

}
