<?php

/**
 * palette
 */
$GLOBALS['TL_DCA']['tl_content']['palettes']['colsStart'] = '{type_legend},type;{colset_legend},column_name,column_color,column_amount,column_sizes,column_expert,column_justify,column_align,column_usecustomgap;{protected_legend:hide},protected;{expert_legend:hide},guests,invisible,cssID,space';

/**
 * Table tl_content
 */
$GLOBALS['TL_DCA']['tl_content']['fields']['column_name'] = array
(
 	'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_name'],
 	'inputType'	=> 'text',
 	'save_callback' => array(array(CreoCode\ContaoColumns\Listener\Dca\ContentListener::class,'setColsetName')),
 	'eval'		=> array('maxlength'=>'255','unique'=>true,'spaceToUnderscore'=>true, 'tl_class'=>'w50'),
    'sql'       => "varchar(255) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_color'] = array
(
 	'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_color'],
    'inputType' => 'text',
    'eval'      => array('maxlength'=>6, 'colorpicker'=>true, 'isHexColor'=>true, 'decodeEntities'=>true, 'tl_class'=>'w50 wizard'),
    'sql'       => "varchar(6) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_amount'] = array
(
	'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_amount'],
	'exclude'	=> true,
	'sorting'	=> true,
	'flag'		=> 3,
	'length'	=> 1,
	'inputType'	=> 'select',
	'options'	=> array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12),
	//'reference'	=> &$GLOBALS['TL_LANG']['tl_columns'],
	'eval'		=> array('submitOnChange' => true, 'tl_class'=>'clr'),
	'sql'		=> "int(10) unsigned NOT NULL default '0'"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_sizes'] = array
(
	'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_sizes'],
	'exclude'	=> true,
	'inputType'	=> 'checkbox',
	'options'	=> array('xs', 'sm', 'md', 'lg', 'xl'),
	'reference'	=> &$GLOBALS['TL_LANG']['tl_content']['column_sizes'],
	'eval'		=> array('multiple' => true, 'submitOnChange' => true),
	'sql'		=> "mediumblob NULL"
);

$colsBreakpoint = array (
	'exclude'				=> true,
	'inputType'				=> 'multiColumnWizard',
	'load_callback'			=> array(array(CreoCode\ContaoColumns\Listener\Columns::class, 'createColumns')),
	'eval'					=> array
	(
		'tl_class'=>'widget-columns-container',
		'includeBlankOption' => true,
		'columnFields'       => array
		(
			'width' => array
			(
				'label' => &$GLOBALS['TL_LANG']['tl_content']['column_amount']['width'],
				'inputType' => 'select',
				'options' => array('auto', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12'),
				'eval' => array('style' => 'min-width: 80px; width: 100%;'),
			),

			'offset' => array
			(
				'label' => &$GLOBALS['TL_LANG']['tl_content']['column_amount']['offset'],
				'inputType' => 'select',
				'options' => array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12'),
				'eval' => array('style' => 'min-width: 80px; width: 100%;', 'includeBlankOption' => true),
			),

            /*
            'h-align' => array
			(
				'label' => &$GLOBALS['TL_LANG']['tl_content']['column_amount']['h-align'],
				'inputType' => 'select',
				'options' => array('start', 'center', 'end'),
				'eval' => array('style' => 'min-width: 100px; width: 100%;', 'includeBlankOption' => true),
			),
            */

            'align' => array
			(
				'label' => &$GLOBALS['TL_LANG']['tl_content']['column_amount']['align'],
				'inputType' => 'select',
				'options' => array('auto', 'top', 'middle', 'bottom'),
				'eval' => array('style' => 'min-width: 80px; width: 100%;', 'includeBlankOption' => true),
			),

			'order' => array
			(
				'label' => &$GLOBALS['TL_LANG']['tl_content']['column_amount']['order'],
				'inputType' => 'select',
				'options' => array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12'),
				'eval' => array('style' => 'min-width: 80px; width: 100%;', 'includeBlankOption' => true),

			),
		),
		'buttons' => array('copy' => false, 'delete' => false),
	),
	'sql' => "blob NULL"
);
$colsExpert = array (
	'exclude'				=> true,
	'inputType'				=> 'multiColumnWizard',
	'load_callback'           => array(array(CreoCode\ContaoColumns\Listener\Columns::class, 'createColumns')),
	'eval'					=> array
	(
		'includeBlankOption' => true,
		'columnFields'       => array
		(
			'cssClass' => array
			(
				'label' => &$GLOBALS['TL_LANG']['tl_content']['column_amount']['cssClass'],
				'inputType' => 'text',
				'eval' => array('style' => 'min-width: 200px; width: 100%;', 'maxlength' => 255),
			),
		),
		'buttons' => array('copy' => false, 'delete' => false),
	),
	'sql' => "blob NULL"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['columns_xs'] = array_merge (
	$colsBreakpoint, array('label' => &$GLOBALS['TL_LANG']['tl_content']['columns_xs'])
);
$GLOBALS['TL_DCA']['tl_content']['fields']['columns_sm'] = array_merge (
	$colsBreakpoint, array('label' => &$GLOBALS['TL_LANG']['tl_content']['columns_sm'])
);
$GLOBALS['TL_DCA']['tl_content']['fields']['columns_md'] = array_merge (
	$colsBreakpoint, array('label' => &$GLOBALS['TL_LANG']['tl_content']['columns_md'])
);
$GLOBALS['TL_DCA']['tl_content']['fields']['columns_lg'] = array_merge (
	$colsBreakpoint, array('label' => &$GLOBALS['TL_LANG']['tl_content']['columns_lg'])
);
$GLOBALS['TL_DCA']['tl_content']['fields']['columns_xl'] = array_merge (
	$colsBreakpoint, array('label' => &$GLOBALS['TL_LANG']['tl_content']['columns_xl'])
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_expert'] = array_merge (
	$colsExpert, array('label' => &$GLOBALS['TL_LANG']['tl_content']['column_expert'])
);


$GLOBALS['TL_DCA']['tl_content']['fields']['column_justify'] = array
(
	'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_justify'],
	'exclude'	=> true,
	'inputType'	=> 'select',
	'options'	=> array('start', 'end', 'center', 'around', 'between', 'evenly'),
	'eval'		=> array('includeBlankOption'=>true, 'tl_class' => 'w50'),
	'sql'		=> "varchar(32) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_align'] = array
(
	'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_align'],
	'exclude'	=> true,
	'inputType'	=> 'select',
	'options'	=> array('start', 'end', 'center'),
	'eval'		=> array('includeBlankOption'=>true, 'tl_class' => 'w50'),
	'sql'		=> "varchar(32) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_usecustomgap'] = array
(
	'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_usecustomgap'],
    'exclude'   => true,
    'inputType' => 'checkbox',
    'eval'      => array('submitOnChange'=>true,'tl_class'=>'clr m12'),
    'sql'       => "char(0) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_gap'] = array
(
	'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_gap'],
    'exclude'   => true,
    'inputType' => 'trbl',
    'options'   => $GLOBALS['TL_CSS_UNITS'],
    'eval'      => array('includeBlankOption'=>true, 'tl_class'=>'w50'),
    'sql'       => "varchar(128) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_containermarginhorizontal'] = array
(
    'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_containermarginhorizontal'],
    'default'	=> 1,
    'inputType'	=> 'checkbox',
    'eval'		=> array('tl_class'=>'clr w50'),
    'sql'       => "char(1) NOT NULL default '1'"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_containermarginvertical'] = array
(
	'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_containermarginvertical'],
	'default'	=> 1,
	'inputType'	=> 'checkbox',
	'eval'		=> array('tl_class'=>'w50'),
    'sql'       => "char(1) NOT NULL default '1'"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_parent'] = array
(
    'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_parent'],
    'sql'       => "int(10) unsigned NOT NULL default '0'"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_childs'] = array
(
    'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_childs'],
    'sql'       => "varchar(255) NOT NULL default ''"
);

$GLOBALS['TL_DCA']['tl_content']['fields']['column_sortid'] = array
(
    'label'		=> &$GLOBALS['TL_LANG']['tl_content']['column_sortid'],
    'sql'       => "int(2) unsigned NOT NULL default '0'"
);

/* Extend existing fields with additional functionality */
$GLOBALS['TL_DCA']['tl_content']['fields']['invisible']['save_callback'][] = array(CreoCode\ContaoColumns\Listener\Dca\ContentListener::class,'toggleAdditionalElements');

//$GLOBALS['TL_DCA']['tl_content']['palettes']['colsPart'] = 'cssID';
//$GLOBALS['TL_DCA']['tl_content']['palettes']['colsEnd'] = $GLOBALS['TL_DCA']['tl_content']['palettes']['default'];

$GLOBALS['TL_DCA']['tl_content']['config']['onload_callback'][] = array(CreoCode\ContaoColumns\Listener\Dca\ContentListener::class,'createPalette');
$GLOBALS['TL_DCA']['tl_content']['config']['onsubmit_callback'][] = array(CreoCode\ContaoColumns\Listener\Dca\ContentListener::class,'updateColumns');
$GLOBALS['TL_DCA']['tl_content']['config']['onsubmit_callback'][] = array(CreoCode\ContaoColumns\Listener\Dca\ContentListener::class,'setElementProperties');
$GLOBALS['TL_DCA']['tl_content']['config']['ondelete_callback'][] = array(CreoCode\ContaoColumns\Listener\Dca\ContentListener::class,'deleteColumns');
$GLOBALS['TL_DCA']['tl_content']['config']['oncopy_callback'][] = array(CreoCode\ContaoColumns\Listener\Dca\ContentListener::class,'copyColumns');
